# -*- coding: utf-8 -*-"

"""The Gyoto Lorene plug-in"""

# Make sure the stdplug and lorene plug-ins are loaded before
# attempting to load the Python bindings 
from gyoto.core import requirePlugin as __gyoto_tmp_requirePlugin
__gyoto_tmp_requirePlugin("stdplug")
__gyoto_tmp_requirePlugin("lorene")
del __gyoto_tmp_requirePlugin

# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.2.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""The Gyoto Lorene plug-in"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _lorene
else:
    import _lorene

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import gyoto.core
class RotStar3_1(gyoto.core.Metric):
    r"""


    Numerical metric around a rotating star in 3+1 formalism.

    C++ includes: GyotoRotStar3_1.h 
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getProperties(self):
        r"""
        getProperties(RotStar3_1 self) -> Property
        Gyoto::Metric::RotStar3_1::getProperties Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.RotStar3_1_getProperties(self)

    def plugins(self, *args):
        r"""
        plugins(RotStar3_1 self, vector_string plugname)
        plugins(RotStar3_1 self) -> vector_string
        """
        return _lorene.RotStar3_1_plugins(self, *args)

    def isThreadSafe(self):
        r"""
        isThreadSafe(RotStar3_1 self) -> bool
        Gyoto::Object::isThreadSafe Whether this class is thread-safe.

        Return True if this object is thread-safe, i.e. if an instance and its
        clone can be used in parallel threads (in the context of
        Scenery::raytrace()). Known objects which are not thread-safe include
        Lorene metrics and everything from the Python plug-in.

        The default implementation considers that the class itself is thread
        safe and recurses into the declared properties to check whether they
        are safe too. Classes that abide to the Object/Property paradigm and
        are themselves thread-safe have nothing special to do.

        Objects that clone children in their copy constructor that are not
        declared as properties must take these children into account.

        Classes that are never thread-safe must declare it. It acn be easily
        done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and
        GYOTO_PROPERTY_THREAD_UNSAFE in the class definition. 
        """
        return _lorene.RotStar3_1_isThreadSafe(self)
    __swig_destroy__ = _lorene.delete_RotStar3_1

    def clone(self):
        r"""
        clone(RotStar3_1 self) -> RotStar3_1
        Gyoto::Metric::RotStar3_1::clone Cloner (uses RotStar3_1(file,
        integ_kind)) 
        """
        return _lorene.RotStar3_1_clone(self)

    def fileName(self, *args):
        r"""
        fileName(RotStar3_1 self, char const * arg2)
        fileName(RotStar3_1 self) -> char const *
        Gyoto::Metric::RotStar3_1::fileName Get filename_. 
        """
        return _lorene.RotStar3_1_fileName(self, *args)

    def file(self, *args):
        r"""
        file(RotStar3_1 self, std::string const & arg2)
        file(RotStar3_1 self) -> std::string
        Gyoto::Metric::RotStar3_1::file Get filename_. 
        """
        return _lorene.RotStar3_1_file(self, *args)

    def integKind(self, *args):
        r"""
        integKind(RotStar3_1 self, int arg2)
        integKind(RotStar3_1 self) -> int
        Gyoto::Metric::RotStar3_1::integKind Get integ_kind_. 
        """
        return _lorene.RotStar3_1_integKind(self, *args)

    def genericIntegrator(self, *args):
        r"""
        genericIntegrator(RotStar3_1 self, bool arg2)
        genericIntegrator(RotStar3_1 self) -> bool
        Gyoto::Metric::RotStar3_1::genericIntegrator Get !integ_kind_. 
        """
        return _lorene.RotStar3_1_genericIntegrator(self, *args)

    def myrk4(self, *args):
        r"""
        myrk4(RotStar3_1 self, Worldline line, vector_double coord, double h, vector_double res) -> int
        myrk4(RotStar3_1 self, double const [6] coord, double h, double [6] res) -> int
        Gyoto::Metric::Generic::myrk4 Obsolete, update your code. 
        """
        return _lorene.RotStar3_1_myrk4(self, *args)

    def myrk4_adaptive(self, *args):
        r"""
        myrk4_adaptive(RotStar3_1 self, Worldline line, vector_double coord, double lastnorm, double normref, vector_double coordnew, double h0, double & h1, double h1max) -> int
        myrk4_adaptive(RotStar3_1 self, double const [6] coor, double lastnorm, double normref, double [6] coornew, double [2] cst, double & tdot_used, double h0, double & h1, double h1max, double & hused) -> int
        Gyoto::Metric::Generic::myrk4_adaptive Obsolete, update your code. 
        """
        return _lorene.RotStar3_1_myrk4_adaptive(self, *args)

    def diff(self, *args):
        r"""
        diff(RotStar3_1 self, vector_double coord, vector_double res, double mass) -> int
        diff(RotStar3_1 self, double const [6] y, double [6] res, int arg4) -> int
        Gyoto::Metric::Generic::diff
        """
        return _lorene.RotStar3_1_diff(self, *args)

    def Normalize4v(self, coordin, coordout, cst, tdot_used):
        r"""
        Normalize4v(RotStar3_1 self, double const [6] coordin, double [6] coordout, double const [2] cst, double & tdot_used)
        Gyoto::Metric::RotStar3_1::Normalize4v Tweak coordinates to insure
        conservation of cst. 
        """
        return _lorene.RotStar3_1_Normalize4v(self, coordin, coordout, cst, tdot_used)

    def gmunu(self, *args):
        r"""
        gmunu(RotStar3_1 self, double const [4] IN_ARRAY1)
        gmunu(RotStar3_1 self, double const [4] x, int mu, int nu) -> double
        Gyoto::Metric::RotStar3_1::gmunu  Metric coefficients.

        The default implementation calls double gmunu(const double * x, int
        mu, int nu) const.

        Parameters:
        -----------

        ARGOUT_ARRAY2:  (g) 4x4 array to store the coeefficients

        IN_ARRAY1:  (x) 4-position at which to compute the coefficients;

        Metric coefficient g, at point x 
        """
        return _lorene.RotStar3_1_gmunu(self, *args)

    def ScalarProd(self, pos, u1, u2):
        r"""
        ScalarProd(RotStar3_1 self, double const [4] pos, double const [4] u1, double const [4] u2) -> double
        Gyoto::Metric::RotStar3_1::ScalarProd Scalar product.

        Compute the scalarproduct of the two quadrivectors u1 and u2 in this
        Metric, at point pos expressed in coordinate system sys.

        Parameters:
        -----------

        pos:  4-position;

        u1:  1st quadrivector;

        u2:  2nd quadrivector;

        u1*u2 
        """
        return _lorene.RotStar3_1_ScalarProd(self, pos, u1, u2)

    def setParameter(self, arg2, arg3, arg4):
        r"""
        setParameter(RotStar3_1 self, std::string arg2, std::string arg3, std::string arg4) -> int
        Gyoto::Object::setParameter Set parameter by Property (and name)

        This function is used when parsing an XML description, if Property (
        p) of this name is found (i.e. either p.name or p.name_false is equal
        to name). Implementation should fall-back on calling the direct's
        parent implementation:

        Parameters:
        -----------

        p:   Property that matches name ( p.name == name or p.name_false ==
        name)

        name:  XML name of the parameter (XML entity)

        content:  string representation of the value

        unit:  string representation of the unit 
        """
        return _lorene.RotStar3_1_setParameter(self, arg2, arg3, arg4)

    def circularVelocity(self, IN_ARRAY1):
        r"""
        circularVelocity(RotStar3_1 self, double const [4] IN_ARRAY1)
        Gyoto::Metric::Generic::circularVelocity Yield circular velocity at a
        given position.

        Give the velocity of a massive particle in circular orbit at the given
        position projected onto the equatorial plane. Such a velocity may not
        exist everywhere (or anywhere) for a given metric. This method is
        intended to be used by Astrobj classes such as Torus or ThinDisk.

        If keplerian_ is set to true, this method should return the Keplerian
        velcity instead (derived classes should ensure this, see
        KerrBL::circularVelocity() for instance).

        The default implementation throws an error if keplerian_ is set to
        false.

        Parameters:
        -----------

        pos:  input: position,

        vel:  output: velocity,

        dir:  1 for corotating, -1 for counterrotating. 
        """
        return _lorene.RotStar3_1_circularVelocity(self, IN_ARRAY1)

    def zamoVelocity(self, IN_ARRAY1):
        r"""
        zamoVelocity(RotStar3_1 self, double const [4] IN_ARRAY1)
        Gyoto::Metric::Generic::zamoVelocity Yield ZAMO velocity at a given
        position.

        Give the velocity of a zero angular momentul observer (whatever is
        closest to "at rest"). The default implementation simply projects
        (1, 0, 0, 0) othogonally along ephi and normalizes it, thus ensuring
        that vel is orthogonal to ephi.

        Parameters:
        -----------

        pos:  input: position,

        vel:  output: velocity, 
        """
        return _lorene.RotStar3_1_zamoVelocity(self, IN_ARRAY1)

    def christoffel(self, *args):
        r"""
        christoffel(RotStar3_1 self, double const [4] coord, int const alpha, int const mu, int const nu) -> double
        christoffel(RotStar3_1 self, double [4][4][4] dst, double const [4] coord) -> int
        christoffel(RotStar3_1 self, double const [8] coord, int const alpha, int const mu, int const nu) -> double
        christoffel(RotStar3_1 self, double const [4] IN_ARRAY1)
        Gyoto::Metric::RotStar3_1::christoffel Chistoffel symbol.

        Value of Christoffel symbol at point (x1, x2, x3).

        1 on error, 0 otherwise 
        """
        return _lorene.RotStar3_1_christoffel(self, *args)

    def __init__(self, *args):
        r"""
        __init__(RotStar3_1 self) -> RotStar3_1
        __init__(RotStar3_1 self, RotStar3_1 arg2) -> RotStar3_1
        __init__(RotStar3_1 self, Metric base) -> RotStar3_1
        __init__(RotStar3_1 self, long address) -> RotStar3_1
        Gyoto::Metric::RotStar3_1::RotStar3_1 Copy constructor. 
        """
        _lorene.RotStar3_1_swiginit(self, _lorene.new_RotStar3_1(*args))

# Register RotStar3_1 in _lorene:
_lorene.RotStar3_1_swigregister(RotStar3_1)
cvar = _lorene.cvar
RotStar3_1.properties = _lorene.cvar.RotStar3_1_properties
RotStar3_1.builtinPluginValue = _lorene.cvar.RotStar3_1_builtinPluginValue

class NumericalMetricLorene(gyoto.core.Metric):
    r"""Proxy of C++ Gyoto::Metric::NumericalMetricLorene class."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getProperties(self):
        r"""
        getProperties(NumericalMetricLorene self) -> Property
        Gyoto::Metric::NumericalMetricLorene::getProperties Get list of
        properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NumericalMetricLorene_getProperties(self)

    def plugins(self, *args):
        r"""
        plugins(NumericalMetricLorene self, vector_string plugname)
        plugins(NumericalMetricLorene self) -> vector_string
        """
        return _lorene.NumericalMetricLorene_plugins(self, *args)

    def isThreadSafe(self):
        r"""
        isThreadSafe(NumericalMetricLorene self) -> bool
        Gyoto::Object::isThreadSafe Whether this class is thread-safe.

        Return True if this object is thread-safe, i.e. if an instance and its
        clone can be used in parallel threads (in the context of
        Scenery::raytrace()). Known objects which are not thread-safe include
        Lorene metrics and everything from the Python plug-in.

        The default implementation considers that the class itself is thread
        safe and recurses into the declared properties to check whether they
        are safe too. Classes that abide to the Object/Property paradigm and
        are themselves thread-safe have nothing special to do.

        Objects that clone children in their copy constructor that are not
        declared as properties must take these children into account.

        Classes that are never thread-safe must declare it. It acn be easily
        done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and
        GYOTO_PROPERTY_THREAD_UNSAFE in the class definition. 
        """
        return _lorene.NumericalMetricLorene_isThreadSafe(self)

    def clone(self):
        r"""
        clone(NumericalMetricLorene self) -> NumericalMetricLorene
        Gyoto::Metric::NumericalMetricLorene::clone Virtual copy constructor.

        """
        return _lorene.NumericalMetricLorene_clone(self)
    __swig_destroy__ = _lorene.delete_NumericalMetricLorene

    def setMetricSource(self):
        r"""
        setMetricSource(NumericalMetricLorene self)
        Gyoto::Metric::NumericalMetricLorene::setMetricSource Access functions
        to get or set private attributes 
        """
        return _lorene.NumericalMetricLorene_setMetricSource(self)

    def directory(self, *args):
        r"""
        directory(NumericalMetricLorene self, std::string const & dir)
        directory(NumericalMetricLorene self) -> std::string
        Gyoto::Metric::NumericalMetricLorene::directory
        """
        return _lorene.NumericalMetricLorene_directory(self, *args)

    def initialTime(self, *args):
        r"""
        initialTime(NumericalMetricLorene self) -> double
        initialTime(NumericalMetricLorene self, double t0)
        Gyoto::Metric::NumericalMetricLorene::initialTime
        """
        return _lorene.NumericalMetricLorene_initialTime(self, *args)

    def horizon(self, *args):
        r"""
        horizon(NumericalMetricLorene self) -> double
        horizon(NumericalMetricLorene self, double t0)
        Gyoto::Metric::NumericalMetricLorene::horizon
        """
        return _lorene.NumericalMetricLorene_horizon(self, *args)

    def rico(self, *args):
        r"""
        rico(NumericalMetricLorene self) -> double
        rico(NumericalMetricLorene self, double r0)
        Gyoto::Metric::NumericalMetricLorene::rico
        """
        return _lorene.NumericalMetricLorene_rico(self, *args)

    def hasSurface(self, *args):
        r"""
        hasSurface(NumericalMetricLorene self) -> bool
        hasSurface(NumericalMetricLorene self, bool s)
        Gyoto::Metric::NumericalMetricLorene::hasSurface
        """
        return _lorene.NumericalMetricLorene_hasSurface(self, *args)

    def hasAccelerationVector(self, *args):
        r"""
        hasAccelerationVector(NumericalMetricLorene self) -> bool
        hasAccelerationVector(NumericalMetricLorene self, bool aa)
        Gyoto::Metric::NumericalMetricLorene::hasAccelerationVector
        """
        return _lorene.NumericalMetricLorene_hasAccelerationVector(self, *args)

    def bosonstarcircular(self, *args):
        r"""
        bosonstarcircular(NumericalMetricLorene self) -> bool
        bosonstarcircular(NumericalMetricLorene self, bool arg2)
        Gyoto::Metric::NumericalMetricLorene::bosonstarcircular
        """
        return _lorene.NumericalMetricLorene_bosonstarcircular(self, *args)

    def specifyMarginalOrbits(self, *args):
        r"""
        specifyMarginalOrbits(NumericalMetricLorene self) -> bool
        specifyMarginalOrbits(NumericalMetricLorene self, bool s)
        Gyoto::Metric::NumericalMetricLorene::specifyMarginalOrbits
        """
        return _lorene.NumericalMetricLorene_specifyMarginalOrbits(self, *args)

    def mapEt(self, *args):
        r"""
        mapEt(NumericalMetricLorene self) -> bool
        mapEt(NumericalMetricLorene self, bool s)
        Gyoto::Metric::NumericalMetricLorene::mapEt
        """
        return _lorene.NumericalMetricLorene_mapEt(self, *args)

    def axisymCirc(self, *args):
        r"""
        axisymCirc(NumericalMetricLorene self) -> bool
        axisymCirc(NumericalMetricLorene self, bool s)
        Gyoto::Metric::NumericalMetricLorene::axisymCirc
        """
        return _lorene.NumericalMetricLorene_axisymCirc(self, *args)

    def getShift_tab(self):
        r"""
        getShift_tab(NumericalMetricLorene self) -> Lorene::Vector **
        Gyoto::Metric::NumericalMetricLorene::getShift_tab
        """
        return _lorene.NumericalMetricLorene_getShift_tab(self)

    def getLapse_tab(self):
        r"""
        getLapse_tab(NumericalMetricLorene self) -> Lorene::Scalar **
        Gyoto::Metric::NumericalMetricLorene::getLapse_tab
        """
        return _lorene.NumericalMetricLorene_getLapse_tab(self)

    def getGamcon_tab(self):
        r"""
        getGamcon_tab(NumericalMetricLorene self) -> Lorene::Sym_tensor **
        Gyoto::Metric::NumericalMetricLorene::getGamcon_tab
        """
        return _lorene.NumericalMetricLorene_getGamcon_tab(self)

    def getGamcov_tab(self):
        r"""
        getGamcov_tab(NumericalMetricLorene self) -> Lorene::Sym_tensor **
        Gyoto::Metric::NumericalMetricLorene::getGamcov_tab
        """
        return _lorene.NumericalMetricLorene_getGamcov_tab(self)

    def getTimes(self):
        r"""
        getTimes(NumericalMetricLorene self) -> double *
        Gyoto::Metric::NumericalMetricLorene::getTimes
        """
        return _lorene.NumericalMetricLorene_getTimes(self)

    def getNbtimes(self):
        r"""
        getNbtimes(NumericalMetricLorene self) -> int
        Gyoto::Metric::NumericalMetricLorene::getNbtimes
        """
        return _lorene.NumericalMetricLorene_getNbtimes(self)

    def getNssurf_tab(self):
        r"""
        getNssurf_tab(NumericalMetricLorene self) -> Lorene::Valeur **
        Gyoto::Metric::NumericalMetricLorene::getNssurf_tab
        """
        return _lorene.NumericalMetricLorene_getNssurf_tab(self)

    def getVsurf_tab(self):
        r"""
        getVsurf_tab(NumericalMetricLorene self) -> Lorene::Vector **
        Gyoto::Metric::NumericalMetricLorene::getVsurf_tab
        """
        return _lorene.NumericalMetricLorene_getVsurf_tab(self)

    def getAccel_tab(self):
        r"""
        getAccel_tab(NumericalMetricLorene self) -> Lorene::Vector **
        Gyoto::Metric::NumericalMetricLorene::getAccel_tab
        """
        return _lorene.NumericalMetricLorene_getAccel_tab(self)

    def getLorentz_tab(self):
        r"""
        getLorentz_tab(NumericalMetricLorene self) -> Lorene::Scalar **
        Gyoto::Metric::NumericalMetricLorene::getLorentz_tab
        """
        return _lorene.NumericalMetricLorene_getLorentz_tab(self)

    def getHor_tab(self):
        r"""
        getHor_tab(NumericalMetricLorene self) -> Lorene::Valeur **
        Gyoto::Metric::NumericalMetricLorene::getHor_tab
        """
        return _lorene.NumericalMetricLorene_getHor_tab(self)

    def getRms(self):
        r"""
        getRms(NumericalMetricLorene self) -> double
        Gyoto::Metric::NumericalMetricLorene::getRms Returns the marginally
        stable (ISCO) radius Should be implemented in derived classes if
        useful If called on the base class, returns an error 
        """
        return _lorene.NumericalMetricLorene_getRms(self)

    def getRmb(self):
        r"""
        getRmb(NumericalMetricLorene self) -> double
        Gyoto::Metric::NumericalMetricLorene::getRmb Returns the marginally
        bound radius Should be implemented in derived classes if useful If
        called on the base class, returns an error 
        """
        return _lorene.NumericalMetricLorene_getRmb(self)

    def setLapse_tab(self, lapse, ii):
        r"""
        setLapse_tab(NumericalMetricLorene self, Lorene::Scalar * lapse, int ii)
        Gyoto::Metric::NumericalMetricLorene::setLapse_tab
        """
        return _lorene.NumericalMetricLorene_setLapse_tab(self, lapse, ii)

    def setShift_tab(self, shift, ii):
        r"""
        setShift_tab(NumericalMetricLorene self, Lorene::Vector * shift, int ii)
        Gyoto::Metric::NumericalMetricLorene::setShift_tab
        """
        return _lorene.NumericalMetricLorene_setShift_tab(self, shift, ii)

    def setGamcov_tab(self, gamcov, ii):
        r"""
        setGamcov_tab(NumericalMetricLorene self, Lorene::Sym_tensor * gamcov, int ii)
        Gyoto::Metric::NumericalMetricLorene::setGamcov_tab
        """
        return _lorene.NumericalMetricLorene_setGamcov_tab(self, gamcov, ii)

    def setGamcon_tab(self, gamcon, ii):
        r"""
        setGamcon_tab(NumericalMetricLorene self, Lorene::Sym_tensor * gamcon, int ii)
        Gyoto::Metric::NumericalMetricLorene::setGamcon_tab
        """
        return _lorene.NumericalMetricLorene_setGamcon_tab(self, gamcon, ii)

    def setKij_tab(self, kij, ii):
        r"""
        setKij_tab(NumericalMetricLorene self, Lorene::Sym_tensor * kij, int ii)
        Gyoto::Metric::NumericalMetricLorene::setKij_tab
        """
        return _lorene.NumericalMetricLorene_setKij_tab(self, kij, ii)

    def setTimes(self, time, ii):
        r"""
        setTimes(NumericalMetricLorene self, double time, int ii)
        Gyoto::Metric::NumericalMetricLorene::setTimes
        """
        return _lorene.NumericalMetricLorene_setTimes(self, time, ii)

    def getSpecificAngularMomentum(self, rr):
        r"""
        getSpecificAngularMomentum(NumericalMetricLorene self, double rr) -> double
        Gyoto::Metric::NumericalMetricLorene::getSpecificAngularMomentum
        Returns the specific angular momentum l=-u_phi/u_t Should be
        implemented in derived classes if useful If called on the base class,
        returns an error 
        """
        return _lorene.NumericalMetricLorene_getSpecificAngularMomentum(self, rr)

    def getPotential(self, pos, l_cst):
        r"""
        getPotential(NumericalMetricLorene self, double const [4] pos, double l_cst) -> double
        Gyoto::Metric::NumericalMetricLorene::getPotential Returns potential
        W=-ln(|u_t|) for a cst specific angular momentum l_cst Should be
        implemented in derived classes if useful If called on the base class,
        returns an error 
        """
        return _lorene.NumericalMetricLorene_getPotential(self, pos, l_cst)

    def computeNBeta(self, coord, NN, beta):
        r"""
        computeNBeta(NumericalMetricLorene self, double const [4] coord, double & NN, double [3] beta)
        Gyoto::Metric::NumericalMetricLorene::computeNBeta Compute lapse and
        shift at given coordinates 
        """
        return _lorene.NumericalMetricLorene_computeNBeta(self, coord, NN, beta)

    def gmunu(self, *args):
        r"""
        gmunu(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        gmunu(NumericalMetricLorene self, double const [4] x, int mu, int nu) -> double
        gmunu(NumericalMetricLorene self, double const [3] x, int indice_time, int mu, int nu) -> double
        Gyoto::Metric::NumericalMetricLorene::gmunu 4- Metric 
        """
        return _lorene.NumericalMetricLorene_gmunu(self, *args)

    def gmunu_up(self, *args):
        r"""
        gmunu_up(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        gmunu_up(NumericalMetricLorene self, double [4][4] gup, double const [4] x, int indice_time)
        Gyoto::Metric::Generic::gmunu_up  Metric contravariant coefficients.

        The default implementation calls Metric:: gmunu_up(double g[4][4],
        const double * pos) const

        Parameters:
        -----------

        x:  4-position at which to compute the coefficient;

        mu:  1st index of coefficient, 03;

        nu:  2nd index of coefficient, 03;

        Metric coefficient g, at point x 
        """
        return _lorene.NumericalMetricLorene_gmunu_up(self, *args)

    def gmunu_di(self, *args):
        r"""
        gmunu_di(NumericalMetricLorene self, double const [4] pos, double [4][4] gmunudr, double [4][4] gmunudth)
        gmunu_di(NumericalMetricLorene self, double const [4] pos, int indice_time, double [4][4] gmunudr, double [4][4] gmunudth)
        Gyoto::Metric::NumericalMetricLorene::gmunu_di
        """
        return _lorene.NumericalMetricLorene_gmunu_di(self, *args)

    def jacobian(self, IN_ARRAY1):
        r"""
        jacobian(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        Gyoto::Metric::NumericalMetricLorene::jacobian Derivatives of the
        metric covariant coefficients.

        The default implementation evaluates them numerically. The gmunu
        matrix is assumed to be symmetrical but no other assumptions are made
        at the moment. 
        """
        return _lorene.NumericalMetricLorene_jacobian(self, IN_ARRAY1)

    def gmunu_up_dr(self, *args):
        r"""
        gmunu_up_dr(NumericalMetricLorene self, double const [4] x, int mu, int nu) -> double
        gmunu_up_dr(NumericalMetricLorene self, double const [3] x, int indice_time, int mu, int nu) -> double
        Gyoto::Metric::NumericalMetricLorene::gmunu_up_dr
        """
        return _lorene.NumericalMetricLorene_gmunu_up_dr(self, *args)

    def Interpol3rdOrder(self, tt, indice_time, values):
        r"""
        Interpol3rdOrder(NumericalMetricLorene self, double tt, int indice_time, double [4] values) -> double
        Gyoto::Metric::NumericalMetricLorene::Interpol3rdOrder 3rd order
        interpolation routine

        Interpolation at order 3 at point tt, the considered function taking
        the values "values" at time indices "indices". 
        """
        return _lorene.NumericalMetricLorene_Interpol3rdOrder(self, tt, indice_time, values)

    def computeHorizon(self, *args):
        r"""
        computeHorizon(NumericalMetricLorene self, double const * pos) -> double
        computeHorizon(NumericalMetricLorene self, double const * pos, int indice) -> double
        Gyoto::Metric::NumericalMetricLorene::computeHorizon
        """
        return _lorene.NumericalMetricLorene_computeHorizon(self, *args)

    def diff(self, *args):
        r"""
        diff(NumericalMetricLorene self, vector_double coord, vector_double res, double mass) -> int
        diff(NumericalMetricLorene self, double tt, double const [7] y, double [7] res) -> int
        diff(NumericalMetricLorene self, double const [7] y, double [7] res, int indice_time) -> int
        Gyoto::Metric::Generic::diff
        """
        return _lorene.NumericalMetricLorene_diff(self, *args)

    def diff31(self, x, dxdt, mass):
        r"""
        diff31(NumericalMetricLorene self, vector_double x, vector_double dxdt, double mass) -> int
        Gyoto::Metric::NumericalMetricLorene::diff31 F function such as
        dx/dt=F(x,cst) for 3+1 case. 
        """
        return _lorene.NumericalMetricLorene_diff31(self, x, dxdt, mass)

    def circularVelocity(self, *args):
        r"""
        circularVelocity(NumericalMetricLorene self, double const [4] coor, double [3] vel, double dir)
        circularVelocity(NumericalMetricLorene self, double const [4] coor, double [3] vel, double dir, int indice_time)
        circularVelocity(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        Gyoto::Metric::Generic::circularVelocity Yield circular velocity at a
        given position.

        Give the velocity of a massive particle in circular orbit at the given
        position projected onto the equatorial plane. Such a velocity may not
        exist everywhere (or anywhere) for a given metric. This method is
        intended to be used by Astrobj classes such as Torus or ThinDisk.

        If keplerian_ is set to true, this method should return the Keplerian
        velcity instead (derived classes should ensure this, see
        KerrBL::circularVelocity() for instance).

        The default implementation throws an error if keplerian_ is set to
        false.

        Parameters:
        -----------

        pos:  input: position,

        vel:  output: velocity,

        dir:  1 for corotating, -1 for counterrotating. 
        """
        return _lorene.NumericalMetricLorene_circularVelocity(self, *args)

    def zamoVelocity(self, IN_ARRAY1):
        r"""
        zamoVelocity(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        Gyoto::Metric::Generic::zamoVelocity Yield ZAMO velocity at a given
        position.

        Give the velocity of a zero angular momentul observer (whatever is
        closest to "at rest"). The default implementation simply projects
        (1, 0, 0, 0) othogonally along ephi and normalizes it, thus ensuring
        that vel is orthogonal to ephi.

        Parameters:
        -----------

        pos:  input: position,

        vel:  output: velocity, 
        """
        return _lorene.NumericalMetricLorene_zamoVelocity(self, IN_ARRAY1)

    def christoffel(self, *args):
        r"""
        christoffel(NumericalMetricLorene self, double const [4] coord, int const alpha, int const mu, int const nu) -> double
        christoffel(NumericalMetricLorene self, double const [4] coord, int const alpha, int const mu, int const nu, int const indice_time) -> double
        christoffel(NumericalMetricLorene self, double [4][4][4] dst, double const [4] coord) -> int
        christoffel(NumericalMetricLorene self, double [4][4][4] dst, double const [4] coord, int const indice_time) -> int
        christoffel(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        Gyoto::Metric::NumericalMetricLorene::christoffel
        """
        return _lorene.NumericalMetricLorene_christoffel(self, *args)

    def __init__(self, *args):
        r"""
        __init__(NumericalMetricLorene self) -> NumericalMetricLorene
        __init__(NumericalMetricLorene self, NumericalMetricLorene arg2) -> NumericalMetricLorene
        __init__(NumericalMetricLorene self, Metric base) -> NumericalMetricLorene
        __init__(NumericalMetricLorene self, long address) -> NumericalMetricLorene
        Gyoto::Metric::NumericalMetricLorene::NumericalMetricLorene Copy
        constructor. 
        """
        _lorene.NumericalMetricLorene_swiginit(self, _lorene.new_NumericalMetricLorene(*args))

# Register NumericalMetricLorene in _lorene:
_lorene.NumericalMetricLorene_swigregister(NumericalMetricLorene)
NumericalMetricLorene.properties = _lorene.cvar.NumericalMetricLorene_properties
NumericalMetricLorene.builtinPluginValue = _lorene.cvar.NumericalMetricLorene_builtinPluginValue

class NeutronStar(gyoto.core.StandardAstrobj):
    r"""


    Neutron star defined by its surface ; no emission.

    The underlying Gyoto::Metric::Generic gg_ instance must be a
    Gyoto::Metric::NumericalMetricLorene describing a neutron star.

    C++ includes: GyotoNeutronStar.h 
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getProperties(self):
        r"""
        getProperties(NeutronStar self) -> Property
        Gyoto::Astrobj::NeutronStar::getProperties Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NeutronStar_getProperties(self)

    def plugins(self, *args):
        r"""
        plugins(NeutronStar self, vector_string plugname)
        plugins(NeutronStar self) -> vector_string
        """
        return _lorene.NeutronStar_plugins(self, *args)

    def clone(self):
        r"""
        clone(NeutronStar self) -> NeutronStar
        Gyoto::Astrobj::NeutronStar::clone Cloner. 
        """
        return _lorene.NeutronStar_clone(self)
    __swig_destroy__ = _lorene.delete_NeutronStar

    def metric(self, *args):
        r"""
        metric(NeutronStar self) -> Gyoto::SmartPointer< Gyoto::Metric::Generic >
        metric(NeutronStar self, Gyoto::SmartPointer< Gyoto::Metric::Generic > met)
        Gyoto::Astrobj::NeutronStar::metric Set gg_. 
        """
        return _lorene.NeutronStar_metric(self, *args)

    def __call__(self, coord):
        r"""__call__(NeutronStar self, double const [4] coord) -> double"""
        return _lorene.NeutronStar___call__(self, coord)

    def getVelocity(self, pos, vel):
        r"""
        getVelocity(NeutronStar self, double const [4] pos, double [4] vel)
        Gyoto::Astrobj::NeutronStar::getVelocity Fluid velocity field.

        Fill vel with the 4-vector velocity of the fluid at 4-position pos.

        Parameters:
        -----------

        pos:  4-position at which to compute velocity;

        vel:  4-velocity at pos. 
        """
        return _lorene.NeutronStar_getVelocity(self, pos, vel)

    def __init__(self, *args):
        r"""
        __init__(NeutronStar self) -> NeutronStar
        __init__(NeutronStar self, std::string kin) -> NeutronStar
        __init__(NeutronStar self, NeutronStar o) -> NeutronStar
        __init__(NeutronStar self, Astrobj base) -> NeutronStar
        __init__(NeutronStar self, long address) -> NeutronStar
        Gyoto::Astrobj::NeutronStar::NeutronStar Copy constructor. 
        """
        _lorene.NeutronStar_swiginit(self, _lorene.new_NeutronStar(*args))

# Register NeutronStar in _lorene:
_lorene.NeutronStar_swigregister(NeutronStar)
NeutronStar.properties = _lorene.cvar.NeutronStar_properties
NeutronStar.builtinPluginValue = _lorene.cvar.NeutronStar_builtinPluginValue

class NeutronStarAnalyticEmission(NeutronStar):
    r"""


    Neutron star emitting at its surface an analytic emission, typically
    blackbody.

    The emission law is given by spectrum_.

    C++ includes: GyotoNeutronStarAnalyticEmission.h 
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getProperties(self):
        r"""
        getProperties(NeutronStarAnalyticEmission self) -> Property
        Gyoto::Astrobj::NeutronStarAnalyticEmission::getProperties Get list of
        properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NeutronStarAnalyticEmission_getProperties(self)

    def plugins(self, *args):
        r"""
        plugins(NeutronStarAnalyticEmission self, vector_string plugname)
        plugins(NeutronStarAnalyticEmission self) -> vector_string
        """
        return _lorene.NeutronStarAnalyticEmission_plugins(self, *args)

    def clone(self):
        r"""
        clone(NeutronStarAnalyticEmission self) -> NeutronStarAnalyticEmission
        Gyoto::Astrobj::NeutronStarAnalyticEmission::clone Cloner. 
        """
        return _lorene.NeutronStarAnalyticEmission_clone(self)
    __swig_destroy__ = _lorene.delete_NeutronStarAnalyticEmission

    def spectrum(self, *args):
        r"""
        spectrum(NeutronStarAnalyticEmission self, Gyoto::SmartPointer< Gyoto::Spectrum::Generic > arg2)
        spectrum(NeutronStarAnalyticEmission self) -> Gyoto::SmartPointer< Gyoto::Spectrum::Generic >
        Gyoto::Astrobj::NeutronStarAnalyticEmission::spectrum
        """
        return _lorene.NeutronStarAnalyticEmission_spectrum(self, *args)

    def emission(self, nu_em, dsem, _ph, _obj=0):
        r"""
        emission(NeutronStarAnalyticEmission self, double nu_em, double dsem, vector_double _ph, double const [8] _obj=0) -> double
        Gyoto::Astrobj::Generic::emission Obsolete, update your code. 
        """
        return _lorene.NeutronStarAnalyticEmission_emission(self, nu_em, dsem, _ph, _obj)

    def __init__(self, *args):
        r"""
        __init__(NeutronStarAnalyticEmission self) -> NeutronStarAnalyticEmission
        __init__(NeutronStarAnalyticEmission self, NeutronStarAnalyticEmission o) -> NeutronStarAnalyticEmission
        __init__(NeutronStarAnalyticEmission self, Astrobj base) -> NeutronStarAnalyticEmission
        __init__(NeutronStarAnalyticEmission self, long address) -> NeutronStarAnalyticEmission
        Gyoto::Astrobj::NeutronStarAnalyticEmission::NeutronStarAnalyticEmission
        Copy constructor. 
        """
        _lorene.NeutronStarAnalyticEmission_swiginit(self, _lorene.new_NeutronStarAnalyticEmission(*args))

# Register NeutronStarAnalyticEmission in _lorene:
_lorene.NeutronStarAnalyticEmission_swigregister(NeutronStarAnalyticEmission)
NeutronStarAnalyticEmission.properties = _lorene.cvar.NeutronStarAnalyticEmission_properties
NeutronStarAnalyticEmission.builtinPluginValue = _lorene.cvar.NeutronStarAnalyticEmission_builtinPluginValue

class NeutronStarModelAtmosphere(NeutronStar):
    r"""


    Neutron star emitting at its surface an emission provided by a FITS
    table.

    C++ includes: GyotoNeutronStarModelAtmosphere.h 
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getProperties(self):
        r"""
        getProperties(NeutronStarModelAtmosphere self) -> Property
        Gyoto::Astrobj::NeutronStarModelAtmosphere::getProperties Get list of
        properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NeutronStarModelAtmosphere_getProperties(self)

    def plugins(self, *args):
        r"""
        plugins(NeutronStarModelAtmosphere self, vector_string plugname)
        plugins(NeutronStarModelAtmosphere self) -> vector_string
        """
        return _lorene.NeutronStarModelAtmosphere_plugins(self, *args)

    def fillProperty(self, fmp, p):
        r"""
        fillProperty(NeutronStarModelAtmosphere self, FactoryMessenger fmp, Property p)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::fillProperty Output a
        single Property to XML.

        The base implementation decides what to do based on the p.type. The
        format matches how setParameters() an setParameter() would interpret
        the XML descition.

        Overriding this method should be avoided, but makes sense in some
        cases (for instance Screen::fillProperty() selects a different unit
        for Distance based on its magnitude, so that stellar sizes are
        expressed in solar radii while smaller sizes can be expressed in
        meters and larger sizes in parsecs).

        Overriding implementation should fall-back on calling the
        implementation in the direct parent class: 
        """
        return _lorene.NeutronStarModelAtmosphere_fillProperty(self, fmp, p)

    def clone(self):
        r"""
        clone(NeutronStarModelAtmosphere self) -> NeutronStarModelAtmosphere
        Gyoto::Astrobj::NeutronStarModelAtmosphere::clone Cloner. 
        """
        return _lorene.NeutronStarModelAtmosphere_clone(self)
    __swig_destroy__ = _lorene.delete_NeutronStarModelAtmosphere

    def file(self, *args):
        r"""
        file(NeutronStarModelAtmosphere self, std::string const & f)
        file(NeutronStarModelAtmosphere self) -> std::string
        Gyoto::Astrobj::NeutronStarModelAtmosphere::file
        """
        return _lorene.NeutronStarModelAtmosphere_file(self, *args)

    def averageOverAngle(self, *args):
        r"""
        averageOverAngle(NeutronStarModelAtmosphere self, bool t)
        averageOverAngle(NeutronStarModelAtmosphere self) -> bool
        Gyoto::Astrobj::NeutronStarModelAtmosphere::averageOverAngle
        """
        return _lorene.NeutronStarModelAtmosphere_averageOverAngle(self, *args)

    def fitsRead(self, filename_):
        r"""fitsRead(NeutronStarModelAtmosphere self, std::string filename_)"""
        return _lorene.NeutronStarModelAtmosphere_fitsRead(self, filename_)

    def fitsWrite(self, filename_):
        r"""fitsWrite(NeutronStarModelAtmosphere self, std::string filename_)"""
        return _lorene.NeutronStarModelAtmosphere_fitsWrite(self, filename_)

    def setEmission(self, pattern):
        r"""
        setEmission(NeutronStarModelAtmosphere self, double * pattern)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::setEmission The pointer is
        copied directly, not the array content.

        This is a low-level function. Beware that: previously allocated array
        will not be freed automatically;

        array attached when the destructor is called will be freed. 
        """
        return _lorene.NeutronStarModelAtmosphere_setEmission(self, pattern)

    def surfgrav(self, pattern):
        r"""
        surfgrav(NeutronStarModelAtmosphere self, double * pattern)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::surfgrav
        """
        return _lorene.NeutronStarModelAtmosphere_surfgrav(self, pattern)

    def copyIntensity(self, pattern=None, naxes=0):
        r"""
        copyIntensity(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t const [3] naxes=0)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::copyIntensity
        NeutronStarModelAtmosphere::emission_ is freed if not NULL,
        reallocated, and pattern is copied into emission_.

        Finally, NeutronStarModelAtmosphere::nnu_,
        NeutronStarModelAtmosphere::ni_, and NeutronStarModelAtmosphere::nsg_
        are set according to naxes.

        Parameters:
        -----------

        pattern:  Array to copy as emission_. May be NULL in which case
        emission_ is simply deallocated and set to NULL.

        naxes:  { nnu_, ni_, nsg_ }. 
        """
        return _lorene.NeutronStarModelAtmosphere_copyIntensity(self, pattern, naxes)

    def getIntensity(self):
        r"""
        getIntensity(NeutronStarModelAtmosphere self) -> double const *
        Gyoto::Astrobj::NeutronStarModelAtmosphere::getIntensity Get
        NeutronStarModelAtmosphere::emission_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getIntensity(self)

    def getIntensityNaxes(self, naxes):
        r"""
        getIntensityNaxes(NeutronStarModelAtmosphere self, size_t [3] naxes)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::getIntensityNaxes Get
        NeutronStarModelAtmosphere::nnu_, NeutronStarModelAtmosphere::ni_, and
        NeutronStarModelAtmosphere::nsg_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getIntensityNaxes(self, naxes)

    def copyGridSurfgrav(self, pattern=None, nsg=0):
        r"""
        copyGridSurfgrav(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t nsg=0)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::copyGridSurfgrav
        """
        return _lorene.NeutronStarModelAtmosphere_copyGridSurfgrav(self, pattern, nsg)

    def getGridSurfgrav(self):
        r"""
        getGridSurfgrav(NeutronStarModelAtmosphere self) -> double const *
        Gyoto::Astrobj::NeutronStarModelAtmosphere::getGridSurfgrav Get
        NeutronStarModelAtmosphere::surfgrav_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getGridSurfgrav(self)

    def copyGridCosi(self, pattern=None, ni=0):
        r"""
        copyGridCosi(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t ni=0)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::copyGridCosi
        """
        return _lorene.NeutronStarModelAtmosphere_copyGridCosi(self, pattern, ni)

    def getGridCosi(self):
        r"""
        getGridCosi(NeutronStarModelAtmosphere self) -> double const *
        Gyoto::Astrobj::NeutronStarModelAtmosphere::getGridCosi Get
        NeutronStarModelAtmosphere::cosi_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getGridCosi(self)

    def copyGridFreq(self, pattern=None, ni=0):
        r"""
        copyGridFreq(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t ni=0)
        Gyoto::Astrobj::NeutronStarModelAtmosphere::copyGridFreq
        """
        return _lorene.NeutronStarModelAtmosphere_copyGridFreq(self, pattern, ni)

    def getGridFreq(self):
        r"""
        getGridFreq(NeutronStarModelAtmosphere self) -> double const *
        Gyoto::Astrobj::NeutronStarModelAtmosphere::getGridFreq Get
        NeutronStarModelAtmosphere::freq_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getGridFreq(self)

    def emission(self, nu_em, dsem, _ph, _obj=0):
        r"""
        emission(NeutronStarModelAtmosphere self, double nu_em, double dsem, vector_double _ph, double const [8] _obj=0) -> double
        Gyoto::Astrobj::Generic::emission Obsolete, update your code. 
        """
        return _lorene.NeutronStarModelAtmosphere_emission(self, nu_em, dsem, _ph, _obj)

    def __init__(self, *args):
        r"""
        __init__(NeutronStarModelAtmosphere self) -> NeutronStarModelAtmosphere
        __init__(NeutronStarModelAtmosphere self, NeutronStarModelAtmosphere o) -> NeutronStarModelAtmosphere
        __init__(NeutronStarModelAtmosphere self, Astrobj base) -> NeutronStarModelAtmosphere
        __init__(NeutronStarModelAtmosphere self, long address) -> NeutronStarModelAtmosphere
        Gyoto::Astrobj::NeutronStarModelAtmosphere::NeutronStarModelAtmosphere
        Copy constructor. 
        """
        _lorene.NeutronStarModelAtmosphere_swiginit(self, _lorene.new_NeutronStarModelAtmosphere(*args))

# Register NeutronStarModelAtmosphere in _lorene:
_lorene.NeutronStarModelAtmosphere_swigregister(NeutronStarModelAtmosphere)
NeutronStarModelAtmosphere.properties = _lorene.cvar.NeutronStarModelAtmosphere_properties
NeutronStarModelAtmosphere.builtinPluginValue = _lorene.cvar.NeutronStarModelAtmosphere_builtinPluginValue


